use StatisticsTest;
go

-- Create a test table
if (object_id('T0', 'U') is not null)
  drop table T0;
go
  
create table T0
 (
   c1 int not null
  ,c2 nchar(200) not null default '#'
 )
go

-- Insert 100000 rows. All rows contain the value 1000 for column c1
insert T0(c1) 
   select 1000 from Numbers
    where n <= 100000
go

-- Now insert only one row with value 2000
insert T0(c1) values(2000)
go

--create a nonclustered index on column c1
create nonclustered index ix_T0_1 on T0(c1)


-- First we investigate the estimated execution plan for the following two queries:
select c1, c2 from T0 where c1=1000
select c1, c2 from T0 where c1=2000
go

-- Now let's execute the queries and have a look at the actual execution plan
select c1, c2 from T0 where c1=1000
select c1, c2 from T0 where c1=2000
go

-- How about the actual execution plan for this query?
select c1, c2 from T0 where c1=1500
go

-- And finally, what's the actual execution plan fr this one?
declare @x int
set @x = 2000
select c1,c2 from T0 
 where c1 = @x
go 
