set nocount on

use StatisticsTest
go


if (object_id('memTest', 'U') is not null)
  drop table memTest
go
create table memTest
 (
   c1 int not null primary key clustered identity(1,1)
  ,c2 int not null
  ,c3 int not null 
  ,c4 nchar(80) not null default '#'
 )
go

-- Insert 10000 rows with a value of 1000 for c1 in every row
insert memTest(c2,c3)
  select 1000, checksum(newid()) 
    from Numbers
   where n <= 10000
go

-- Insert 200 more rows with values of 1-200 for c1
insert memTest(c2, c3)
   select n, 100
     from Numbers
    where n <= 200
go
create index ix_memTest_c2 on memTest(c2) 
go

-- Log execution times
set statistics time on


-- Estimated and actual plan
declare @x int 
       ,@res nchar(80)
set @x = 1000
select @res=c4
  from memTest
 where c2 = @x
 order by c3
go

-- Compare to this
declare @res nchar(80)
select @res=c4
  from memTest
 where c2 = 1000
 order by c3 
go


-- See tempdb utilization
declare @x int 
       ,@res nchar(80)
set @x = 1000

select sum(num_of_bytes_read)/1024./1024. as mbytes_read
      ,sum(num_of_bytes_written)/1024./1024. as mbytes_written
  from sys.dm_io_virtual_file_stats(2,null)

  select @res=c4
    from memTest
   where c2 = @x
   order by c3

select sum(num_of_bytes_read)/1024./1024. as mbytes_read
      ,sum(num_of_bytes_written)/1024./1024. as mbytes_written
  from sys.dm_io_virtual_file_stats(2,null)
go



declare @res nchar(80)

select sum(num_of_bytes_read)/1024./1024. as mbytes_read
      ,sum(num_of_bytes_written)/1024./1024. as mbytes_written
  from sys.dm_io_virtual_file_stats(2,null)

  select @res=c4
    from memTest
   where c2 = 1000
   order by c3

select sum(num_of_bytes_read)/1024./1024. as mbytes_read
      ,sum(num_of_bytes_written)/1024./1024. as mbytes_written
  from sys.dm_io_virtual_file_stats(2,null)
go


set statistics io off
set statistics time off


-- Watch memory allocation

-- Local var
declare @x int 
       ,@res nchar(80)
while (1=1)
 begin
  set @x = 1000
  select @res=c4
    from memTest
   where c2 = @x
   order by c3
 end
go

-- Constant
declare @res nchar(80)
while (1=1)
 begin
  select @res=c4
    from memTest
   where c2 = 1000
   order by c3 
 end
go


-- Local var with query hint
declare @x int 
       ,@res nchar(80)
while (1=1)
 begin
  set @x = 1000
  select @res=c4
    from memTest
   where c2 = @x
   order by c3 option (optimize for (@x=1000))
 end
go








select session_id
      ,requested_memory_kb / 1024.0 as requested_memory_mb
      ,granted_memory_kb / 1024.0 as granted_memory_mb
      ,used_memory_kb / 1024.0 as used_memory_mb
      ,max_used_memory_kb / 1024.0 as max_used_memory_mb
      ,request_time
  from sys.dm_exec_query_memory_grants
 where session_id = 59
go 





  --select sum(num_of_bytes_read)/1024./1024. as mbytes_read
  --      ,sum(num_of_bytes_written)/1024./1024. as mbytes_written
  --  from sys.dm_io_virtual_file_stats(2,null)


